﻿package {
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.display.StageAlign;
	import flash.events.Event;
	import flash.filters.ColorMatrixFilter;
	import flash.media.Camera;
	import flash.media.Video;
	
	import ImageDetector;
	
	public class Main extends Sprite {
		var video:Video;
		var camera:Camera;
		var currentFrame:BitmapData;
		var detector:ImageDetector;
		
		var bmOriginalVideo:BitmapData;
		var bmProcessedVideo:BitmapData;
		
		public function Main() {
			trace("main");
			var w = 320;
			var h = 240;
			currentFrame = null;
			stage.align = StageAlign.TOP_LEFT;
			
			camera = Camera.getCamera();
			camera.setMode(w, h, stage.frameRate);
			video = new Video(w, h);
			video.attachCamera(camera);
			
			bmOriginalVideo = addVideoDisplay(w, h, w);
			bmProcessedVideo = addVideoDisplay(w, h, w+w+5);
			
			detector = new ImageDetector(10, 10, 40, 40);
			
			addEventListener(Event.ENTER_FRAME, update);
		}
		
		function addVideoDisplay(w:Number, h:Number, x:Number):BitmapData {
			var bm:BitmapData = new BitmapData(w, h, false, 0);
			var _source = new Bitmap(bm);
			_source.scaleX = -1;
			_source.x = x;
			addChild(_source);
			return bm;
		}
		
		function update(e:Event):void {
			if (currentFrame != null)
				currentFrame.dispose();
			currentFrame = new BitmapData(video.width, video.height, false, 0);
			currentFrame.draw(video);
			var r:Array = detector.process(currentFrame);
			// r[0]  => diff BitmapData
			// r[1]  => blocks BitmapData
			// r[2]  => blocks Array
			// video => original, unprocessed video
			bmProcessedVideo.draw(r[1]);
			bmOriginalVideo.draw(video);
		}
	}
}